'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var jsxRuntime = require('react/jsx-runtime');
var styled = require('styled-components');
var react = require('react');
var bech32 = require('bech32');
var buffer = require('buffer');
var Color = require('color');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var styled__default = /*#__PURE__*/_interopDefaultLegacy(styled);
var Color__default = /*#__PURE__*/_interopDefaultLegacy(Color);

/******************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

function __awaiter(thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
}

function __generator(thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
}

function __makeTemplateObject(cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
}

var SignErrorCode;
(function (SignErrorCode) {
    SignErrorCode[SignErrorCode["WalletExtensionNotFound"] = 0] = "WalletExtensionNotFound";
    SignErrorCode[SignErrorCode["EnablementFailed"] = 1] = "EnablementFailed";
})(SignErrorCode || (SignErrorCode = {}));

var Menu$1 = styled__default["default"].div(templateObject_1$1 || (templateObject_1$1 = __makeTemplateObject(["\n  display: none;\n  position: absolute;\n  margin-top: 8px;\n  font-family: sans-serif;\n  width: 160px;\n  z-index: 2;\n"], ["\n  display: none;\n  position: absolute;\n  margin-top: 8px;\n  font-family: sans-serif;\n  width: 160px;\n  z-index: 2;\n"])));
var MenuItem$1 = styled__default["default"].span(templateObject_2$1 || (templateObject_2$1 = __makeTemplateObject(["\n  color: ", ";\n  padding: 12px 16px;\n  text-decoration: none;\n  display: flex;\n  opacity: 0.6;\n  align-items: center;\n  cursor: pointer;\n  border-color: ", ";\n  border-style: solid;\n  border-width: 1px;\n  border-bottom: none;\n\n  transition: background-color 250ms cubic-bezier(0.4, 0, 0.2, 1) 0ms,\n    border-color 250ms cubic-bezier(0.4, 0, 0.2, 1) 0ms,\n    color 250ms cubic-bezier(0.4, 0, 0.2, 1) 0ms;\n\n  ", "\n\n  &:hover {\n    opacity: 1;\n    background-color: ", ";\n  }\n\n  &:first-child {\n    border-top-left-radius: 15px;\n    border-top-right-radius: 15px;\n    border-bottom: none;\n  }\n\n  &:last-child {\n    border-bottom-left-radius: 16px;\n    border-bottom-right-radius: 16px;\n    border-bottom: 1px solid ", ";\n  }\n"], ["\n  color: ", ";\n  padding: 12px 16px;\n  text-decoration: none;\n  display: flex;\n  opacity: 0.6;\n  align-items: center;\n  cursor: pointer;\n  border-color: ", ";\n  border-style: solid;\n  border-width: 1px;\n  border-bottom: none;\n\n  transition: background-color 250ms cubic-bezier(0.4, 0, 0.2, 1) 0ms,\n    border-color 250ms cubic-bezier(0.4, 0, 0.2, 1) 0ms,\n    color 250ms cubic-bezier(0.4, 0, 0.2, 1) 0ms;\n\n  ", "\n\n  &:hover {\n    opacity: 1;\n    background-color: ", ";\n  }\n\n  &:first-child {\n    border-top-left-radius: 15px;\n    border-top-right-radius: 15px;\n    border-bottom: none;\n  }\n\n  &:last-child {\n    border-bottom-left-radius: 16px;\n    border-bottom-right-radius: 16px;\n    border-bottom: 1px solid ", ";\n  }\n"])), function (props) { return props.primaryColor; }, function (props) { return props.primaryColor; }, function (props) {
    return props.borderRadius && "border-radius: ".concat(props.borderRadius, "px;");
}, function (props) { return props.primaryColorLight; }, function (props) { return props.primaryColor; });
var MenuItemIcon$1 = styled__default["default"].img(templateObject_3$1 || (templateObject_3$1 = __makeTemplateObject(["\n  width: 24px;\n  height: 24px;\n  margin-right: 8px;\n"], ["\n  width: 24px;\n  height: 24px;\n  margin-right: 8px;\n"])));
var Button = styled__default["default"].button(templateObject_4 || (templateObject_4 = __makeTemplateObject(["\n  padding: 16px;\n  cursor: pointer;\n  font-size: 16px;\n  font-weight: bold;\n  width: 100%;\n  border: 1px solid ", ";\n  border-radius: 16px;\n  color: ", ";\n  background-color: white;\n\n  &:disabled {\n    border: 1px solid #333;\n    color: #333;\n    backgroundcolor: #eee;\n  }\n"], ["\n  padding: 16px;\n  cursor: pointer;\n  font-size: 16px;\n  font-weight: bold;\n  width: 100%;\n  border: 1px solid ", ";\n  border-radius: 16px;\n  color: ", ";\n  background-color: white;\n\n  &:disabled {\n    border: 1px solid #333;\n    color: #333;\n    backgroundcolor: #eee;\n  }\n"])), function (props) { return props.primaryColor; }, function (props) { return props.primaryColor; });
var Dropdown = styled__default["default"].div(templateObject_5 || (templateObject_5 = __makeTemplateObject(["\n  width: 160px;\n  font-weight: bold;\n  position: relative;\n  display: inline-block;\n  padding-bottom: 8px;\n\n  ", "\n\n  &:hover ", " {\n    display: block;\n  }\n\n  &:hover ", " {\n    background-color: ", ";\n    color: white;\n  }\n"], ["\n  width: 160px;\n  font-weight: bold;\n  position: relative;\n  display: inline-block;\n  padding-bottom: 8px;\n\n  ", "\n\n  &:hover ", " {\n    display: block;\n  }\n\n  &:hover ", " {\n    background-color: ", ";\n    color: white;\n  }\n"])), function (props) { return props.customCSS; }, Menu$1, Button, function (props) { return props.primaryColor; });
var templateObject_1$1, templateObject_2$1, templateObject_3$1, templateObject_4, templateObject_5;

var getInstalledWalletExtensions = function (supportedWallets) {
    var cardano = window.cardano;
    if (supportedWallets.length === 0 || typeof cardano === 'undefined') {
        return [];
    }
    return Object.keys(cardano).filter(function (walletExtension) {
        return supportedWallets
            .map(function (walletName) { return walletName.toLowerCase(); })
            .includes(walletExtension.toLowerCase());
    });
};

var Observable = /** @class */ (function () {
    function Observable(value) {
        this.observers = new Array();
        this.value = value;
    }
    Observable.prototype.subscribe = function (subscriber) {
        this.observers.push(subscriber);
    };
    Observable.prototype.unsubscribe = function (subscriber) {
        this.observers = this.observers.filter(function (observer) { return observer !== subscriber; });
    };
    Observable.prototype.get = function () {
        return this.value;
    };
    Observable.prototype.set = function (value) {
        if (this.value === value)
            return;
        this.value = value;
        for (var _i = 0, _a = this.observers; _i < _a.length; _i++) {
            var observer = _a[_i];
            observer(this.value);
        }
    };
    return Observable;
}());

var useLocalStorage = function (keyName, defaultValue) {
    var getVariableFromLocalStorage = function () {
        try {
            var value = window.localStorage.getItem(keyName);
            if (value) {
                return JSON.parse(value);
            }
            else {
                window.localStorage.setItem(keyName, JSON.stringify(defaultValue));
                return defaultValue;
            }
        }
        catch (err) {
            return defaultValue;
        }
    };
    var _a = react.useState(getVariableFromLocalStorage), storedValue = _a[0], setStoredValue = _a[1];
    var setValue = function (newValue) {
        try {
            window.localStorage.setItem(keyName, JSON.stringify(newValue));
        }
        catch (err) { }
        setStoredValue(newValue);
    };
    react.useEffect(function () {
        var storageEventHandler = function () {
            setStoredValue(getVariableFromLocalStorage());
        };
        window.addEventListener('storage', storageEventHandler);
        return function () { return window.removeEventListener('storage', storageEventHandler); };
    }, []);
    return [storedValue, setValue];
};

var capitalize = function (word) {
    return word.charAt(0).toUpperCase() + word.slice(1);
};
var formatSupportedWallets = function (supportedWallets) {
    if (supportedWallets.length > 1) {
        return "".concat(supportedWallets.slice(0, -1).join(', '), " or ").concat(supportedWallets.slice(-1)[0]);
    }
    else {
        return supportedWallets[0];
    }
};

var enabledObserver = new Observable(false);
var enabledWalletObserver = new Observable(null);
var stakeAddressObserver = new Observable(null);
function useCardano() {
    var _this = this;
    var _a = react.useState(enabledObserver.get()), isEnabled = _a[0], setIsEnabled = _a[1];
    var _b = react.useState(enabledWalletObserver.get()), enabledWallet = _b[0], setEnabledWallet = _b[1];
    var _c = react.useState(stakeAddressObserver.get()), stakeAddress = _c[0], setStakeAddress = _c[1];
    var _d = useLocalStorage('cf-wallet-connected', false), isConnected = _d[0], setIsConnected = _d[1];
    react.useEffect(function () {
        enabledObserver.subscribe(setIsEnabled);
        enabledWalletObserver.subscribe(setEnabledWallet);
        stakeAddressObserver.subscribe(setStakeAddress);
        return function () {
            enabledObserver.unsubscribe(setIsEnabled);
            enabledWalletObserver.unsubscribe(setEnabledWallet);
            stakeAddressObserver.unsubscribe(setStakeAddress);
        };
    }, []);
    var disconnect = react.useCallback(function () {
        setIsConnected(false);
        window.dispatchEvent(new Event('storage'));
        enabledObserver.set(false);
        enabledWalletObserver.set(null);
        stakeAddressObserver.set(null);
    }, []);
    var checkEnabled = react.useCallback(function () { return __awaiter(_this, void 0, void 0, function () {
        var cardano, walletExtensions, _i, walletExtensions_1, walletExtension, hexAddress, addressBytes, words, bech32Address;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    cardano = window.cardano;
                    if (typeof cardano === 'undefined') {
                        return [2 /*return*/];
                    }
                    walletExtensions = Object.keys(cardano);
                    _i = 0, walletExtensions_1 = walletExtensions;
                    _a.label = 1;
                case 1:
                    if (!(_i < walletExtensions_1.length)) return [3 /*break*/, 6];
                    walletExtension = walletExtensions_1[_i];
                    if (!(typeof cardano[walletExtension].isEnabled === 'function')) return [3 /*break*/, 5];
                    return [4 /*yield*/, cardano[walletExtension].isEnabled()];
                case 2:
                    if (!_a.sent()) return [3 /*break*/, 5];
                    enabledWalletObserver.set(walletExtension);
                    enabledObserver.set(true);
                    if (!(typeof cardano.getRewardAddress === 'function')) return [3 /*break*/, 4];
                    return [4 /*yield*/, cardano.getRewardAddress()];
                case 3:
                    hexAddress = _a.sent();
                    addressBytes = buffer.Buffer.from(hexAddress, 'hex');
                    words = bech32.bech32.toWords(addressBytes);
                    bech32Address = bech32.bech32.encode('stake', words, 1000);
                    stakeAddressObserver.set(bech32Address);
                    _a.label = 4;
                case 4: return [2 /*return*/];
                case 5:
                    _i++;
                    return [3 /*break*/, 1];
                case 6: return [2 /*return*/];
            }
        });
    }); }, []);
    var signMessage = react.useCallback(function (message, onSignMessage) { return __awaiter(_this, void 0, void 0, function () {
        var cardano, hexAddress, hexMessage, i, l, signedMessage, error_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!isEnabled) {
                        return [2 /*return*/];
                    }
                    cardano = window.cardano;
                    if (typeof message === 'undefined') {
                        return [2 /*return*/];
                    }
                    return [4 /*yield*/, cardano.getRewardAddress()];
                case 1:
                    hexAddress = _a.sent();
                    hexMessage = '';
                    for (i = 0, l = message.length; i < l; i++) {
                        hexMessage += message.charCodeAt(i).toString(16);
                    }
                    _a.label = 2;
                case 2:
                    _a.trys.push([2, 4, , 5]);
                    return [4 /*yield*/, cardano.signData(hexAddress, hexMessage)];
                case 3:
                    signedMessage = _a.sent();
                    if (typeof onSignMessage === 'function') {
                        onSignMessage(signedMessage);
                    }
                    return [3 /*break*/, 5];
                case 4:
                    error_1 = _a.sent();
                    console.warn(error_1);
                    return [3 /*break*/, 5];
                case 5: return [2 /*return*/];
            }
        });
    }); }, [isEnabled]);
    var connect = function (walletName, onConnect, onError) { return __awaiter(_this, void 0, void 0, function () {
        var cardano, error_2;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    cardano = window.cardano;
                    if (!(typeof cardano !== 'undefined')) return [3 /*break*/, 7];
                    if (!(typeof cardano[walletName] !== 'undefined')) return [3 /*break*/, 5];
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, cardano[walletName].enable()];
                case 2:
                    _a.sent();
                    checkEnabled();
                    if (typeof onConnect === 'function') {
                        setIsConnected(true);
                        window.dispatchEvent(new Event('storage'));
                        onConnect();
                    }
                    return [3 /*break*/, 4];
                case 3:
                    error_2 = _a.sent();
                    console.warn(error_2);
                    if (typeof onError === 'function') {
                        onError(SignErrorCode.EnablementFailed);
                    }
                    return [3 /*break*/, 4];
                case 4: return [3 /*break*/, 6];
                case 5:
                    if (typeof onError === 'function') {
                        onError(SignErrorCode.WalletExtensionNotFound);
                    }
                    _a.label = 6;
                case 6: return [3 /*break*/, 8];
                case 7:
                    if (typeof onError === 'function') {
                        onError(SignErrorCode.WalletExtensionNotFound);
                    }
                    _a.label = 8;
                case 8: return [2 /*return*/];
            }
        });
    }); };
    react.useEffect(function () {
        if (isConnected) {
            checkEnabled();
        }
    }, [isConnected]);
    var getAvailableWallets = function (supportedWallets) { return __awaiter(_this, void 0, void 0, function () {
        var cardano, walletExtensions, availableWallets, _i, walletExtensions_2, walletExtension, _a, _b;
        var _c;
        return __generator(this, function (_d) {
            switch (_d.label) {
                case 0:
                    cardano = window.cardano;
                    if (typeof cardano === 'undefined') {
                        return [2 /*return*/, []];
                    }
                    walletExtensions = Object.keys(cardano);
                    if (supportedWallets) {
                        walletExtensions = getInstalledWalletExtensions(supportedWallets);
                    }
                    availableWallets = [];
                    _i = 0, walletExtensions_2 = walletExtensions;
                    _d.label = 1;
                case 1:
                    if (!(_i < walletExtensions_2.length)) return [3 /*break*/, 4];
                    walletExtension = walletExtensions_2[_i];
                    if (!(typeof cardano[walletExtension].isEnabled === 'function')) return [3 /*break*/, 3];
                    _b = (_a = availableWallets).push;
                    _c = {
                        name: capitalize(cardano[walletExtension].name)
                    };
                    return [4 /*yield*/, cardano[walletExtension].isEnabled()];
                case 2:
                    _b.apply(_a, [(_c.isEnabled = _d.sent(),
                            _c.apiVersion = cardano[walletExtension].apiVersion,
                            _c.icon = cardano[walletExtension].icon,
                            _c)]);
                    _d.label = 3;
                case 3:
                    _i++;
                    return [3 /*break*/, 1];
                case 4: return [2 /*return*/, availableWallets];
            }
        });
    }); };
    return {
        isEnabled: isEnabled,
        isConnected: isConnected,
        enabledWallet: enabledWallet,
        stakeAddress: stakeAddress,
        signMessage: signMessage,
        connect: connect,
        disconnect: disconnect,
        getAvailableWallets: getAvailableWallets,
    };
}

var ConnectWalletButton = function (_a) {
    var _b = _a.label, label = _b === void 0 ? 'Connect Wallet' : _b, disabled = _a.disabled, message = _a.message, _c = _a.supportedWallets, supportedWallets = _c === void 0 ? ['Nami', 'Eternl', 'Flint', 'Yoroi'] : _c, primaryColor = _a.primaryColor, customCSS = _a.customCSS, _d = _a.customActions, customActions = _d === void 0 ? [] : _d, onConnect = _a.onConnect, onDisconnect = _a.onDisconnect, onSignMessage = _a.onSignMessage;
    var cardano = window.cardano;
    var availableWallets = getInstalledWalletExtensions(supportedWallets);
    var _e = useCardano(), isEnabled = _e.isEnabled, stakeAddress = _e.stakeAddress, signMessage = _e.signMessage, connect = _e.connect, disconnect = _e.disconnect, isConnected = _e.isConnected;
    var connectWallet = function (walletName) { return __awaiter(void 0, void 0, void 0, function () {
        var onSuccess, onError;
        return __generator(this, function (_a) {
            onSuccess = function () {
                if (typeof onConnect === 'function') {
                    onConnect();
                }
            };
            onError = function (code) {
                if (code === SignErrorCode.WalletExtensionNotFound) {
                    alert("Please make sure you are using a modern browser and the ".concat(walletName, " browser extension has been installed."));
                }
                else {
                    alert("Something went wrong. Please try again later.");
                }
            };
            connect(walletName, onSuccess, onError);
            return [2 /*return*/];
        });
    }); };
    var themeColorObject = primaryColor
        ? Color__default["default"](primaryColor)
        : Color__default["default"]('#0538AF');
    var buttonTitle = stakeAddress && isConnected ? "".concat(stakeAddress.slice(0, 12), "...") : label;
    var walletMenu = (jsxRuntime.jsx(Menu$1, { children: availableWallets ? (availableWallets.map(function (availableWallet) { return (jsxRuntime.jsxs(MenuItem$1, __assign({ primaryColor: themeColorObject.hex(), primaryColorLight: themeColorObject.alpha(0.2).hexa(), onClick: function () { return connectWallet(availableWallet); } }, { children: [jsxRuntime.jsx(MenuItemIcon$1, { src: cardano[availableWallet].icon }), capitalize(availableWallet)] }), availableWallet)); })) : (jsxRuntime.jsx("span", { children: "Please install a wallet browser extension (".concat(formatSupportedWallets(supportedWallets), " are supported)") })) }));
    var actionMenu = (jsxRuntime.jsxs(Menu$1, { children: [typeof message === 'string' && (jsxRuntime.jsx(MenuItem$1, __assign({ primaryColor: themeColorObject.hex(), primaryColorLight: themeColorObject.alpha(0.1).hexa(), onClick: function () { return signMessage(message, onSignMessage); } }, { children: "Sign a message" }))), customActions.map(function (customAction, index) { return (jsxRuntime.jsx(MenuItem$1, __assign({ primaryColor: themeColorObject.hex(), primaryColorLight: themeColorObject.alpha(0.1).hexa(), onClick: customAction.onClick }, { children: customAction.label }), "custom-action-".concat(index))); }), jsxRuntime.jsx(MenuItem$1, __assign({ primaryColor: themeColorObject.hex(), primaryColorLight: themeColorObject.alpha(0.1).hexa(), onClick: function () {
                    disconnect();
                    if (typeof onDisconnect === 'function') {
                        onDisconnect();
                    }
                } }, { children: "Disconnect" }))] }));
    return (jsxRuntime.jsxs(Dropdown, __assign({ customCSS: customCSS, primaryColor: themeColorObject.hex() }, { children: [jsxRuntime.jsx(Button, __assign({ primaryColor: themeColorObject.hex() }, { children: buttonTitle })), !disabled && (isEnabled && isConnected ? actionMenu : walletMenu)] })));
};

var Menu = styled__default["default"].div(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  font-family: sans-serif;\n  max-width: 180px;\n  z-index: 1;\n  ", "\n"], ["\n  font-family: sans-serif;\n  max-width: 180px;\n  z-index: 1;\n  ", "\n"])), function (props) { return props.customCSS; });
var MenuItem = styled__default["default"].span(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n  color: ", ";\n  padding: 12px 16px;\n  text-decoration: none;\n  display: flex;\n  opacity: 0.8;\n  transition: background-color 250ms cubic-bezier(0.4, 0, 0.2, 1) 0ms,\n    border-color 250ms cubic-bezier(0.4, 0, 0.2, 1) 0ms,\n    color 250ms cubic-bezier(0.4, 0, 0.2, 1) 0ms;\n  align-items: center;\n  cursor: pointer;\n  border-color: ", ";\n  border-style: solid;\n  border-width: 1px;\n\n  ", "\n\n  ", "\n\n  &:hover {\n    opacity: 1;\n    background-color: ", ";\n  }\n"], ["\n  color: ", ";\n  padding: 12px 16px;\n  text-decoration: none;\n  display: flex;\n  opacity: 0.8;\n  transition: background-color 250ms cubic-bezier(0.4, 0, 0.2, 1) 0ms,\n    border-color 250ms cubic-bezier(0.4, 0, 0.2, 1) 0ms,\n    color 250ms cubic-bezier(0.4, 0, 0.2, 1) 0ms;\n  align-items: center;\n  cursor: pointer;\n  border-color: ", ";\n  border-style: solid;\n  border-width: 1px;\n\n  ", "\n\n  ", "\n\n  &:hover {\n    opacity: 1;\n    background-color: ", ";\n  }\n"])), function (props) { return props.primaryColor; }, function (props) { return props.primaryColor; }, function (props) {
    return props.gap
        ? "margin-bottom: ".concat(props.gap, "px;")
        : "&:first-child {\n        border-bottom: none;\n    }";
}, function (props) {
    return props.borderRadius && "border-radius: ".concat(props.borderRadius, "px;");
}, function (props) { return props.primaryColorLight; });
var MenuItemIcon = styled__default["default"].img(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n  width: 24px;\n  height: 24px;\n  margin-right: 8px;\n"], ["\n  width: 24px;\n  height: 24px;\n  margin-right: 8px;\n"])));
var templateObject_1, templateObject_2, templateObject_3;

var ConnectWalletList = function (_a) {
    var _b = _a.supportedWallets, supportedWallets = _b === void 0 ? ['Nami', 'Eternl', 'Flint', 'Yoroi'] : _b, onConnect = _a.onConnect, primaryColor = _a.primaryColor, borderRadius = _a.borderRadius, gap = _a.gap, customCSS = _a.customCSS;
    var cardano = window.cardano;
    var availableWallets = getInstalledWalletExtensions(supportedWallets);
    var connect = useCardano().connect;
    var connectWallet = function (walletName) { return __awaiter(void 0, void 0, void 0, function () {
        var onSuccess, onError;
        return __generator(this, function (_a) {
            onSuccess = function () {
                if (typeof onConnect === 'function') {
                    onConnect();
                }
            };
            onError = function (code) {
                if (code === SignErrorCode.WalletExtensionNotFound) {
                    alert("Please make sure you are using a modern browser and the ".concat(walletName, " browser extension has been installed."));
                }
                else {
                    alert("Something went wrong. Please try again later.");
                }
            };
            connect(walletName, onSuccess, onError);
            return [2 /*return*/];
        });
    }); };
    var themeColorObject = primaryColor
        ? Color__default["default"](primaryColor)
        : Color__default["default"]('#0538AF');
    return (jsxRuntime.jsx(Menu, __assign({ customCSS: customCSS }, { children: availableWallets ? (availableWallets.map(function (availableWallet) { return (jsxRuntime.jsxs(MenuItem, __assign({ primaryColor: themeColorObject.hex(), primaryColorLight: themeColorObject.alpha(0.1).hexa(), borderRadius: borderRadius, gap: gap, onClick: function () { return connectWallet(availableWallet); } }, { children: [jsxRuntime.jsx(MenuItemIcon, { src: cardano[availableWallet].icon }), capitalize(availableWallet)] }), availableWallet)); })) : (jsxRuntime.jsx("span", { children: "Please install a wallet browser extension (".concat(formatSupportedWallets(supportedWallets), " are supported)") })) })));
};

exports.ConnectWalletButton = ConnectWalletButton;
exports.ConnectWalletList = ConnectWalletList;
exports.Observable = Observable;
exports.getInstalledWalletExtensions = getInstalledWalletExtensions;
exports.useCardano = useCardano;
exports.useLocalStorage = useLocalStorage;
//# sourceMappingURL=index.js.map
